varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform float  u_time;

uniform highp vec4 u_interval; //pos u, pov, size u, size v
uniform highp vec4 u_displacement;// base speed u, base speed v, gradient speed u

void main()
{	
	highp vec2 uv = v_texCoord;

	//***** uncomment this to animate in F.E.*****
	highp vec4 displacement = u_displacement * u_time;
	//***********

	//vec4 displacement = u_displacement;

	//Base displacement
	uv.x += displacement.x;
	uv.y += displacement.y;

	//get base texture color
	highp vec4 baseColor = texture2D(u_texture, fract(uv));
	
	//get grey scale color
	lowp float gsColor = dot(baseColor.rgb, vec3(0.299, 0.587, 0.114));

	//Interval
	highp vec2 intervalPos;
	intervalPos.x = u_interval.x + displacement.z;
	intervalPos.y = u_interval.y;
	highp vec2 intervalSize;
	intervalSize.x = u_interval.z;
	intervalSize.y = u_interval.w;
	
	//UV Gradient
	highp vec2 uvGradient;
	uvGradient.x = intervalPos.x + (gsColor * intervalSize.x);
	uvGradient.y = intervalPos.y + (intervalSize.y * uvGradient.x);
	
	//get gradient texture color
	highp vec4 gradientColor = texture2D(u_texture1, fract(uvGradient));

	gl_FragColor.rgb = gradientColor.rgb * v_color.rgb;
	gl_FragColor.a = baseColor.a * gradientColor.a * v_color.a;
}
