varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

uniform vec4 u_interval; //pos u, pos v, size u, size v
uniform vec4 u_multiplier; //alpha mult, gradient y mult, void, void
	
void main()
{	
	//get base texture color
	vec4 baseColor = texture2D(u_texture, v_texCoord);
	
	//get grey scale color
	highp float gsColor = dot(baseColor.rgb, vec3(0.299, 0.587, 0.114));

	//Interval
	vec2 intervalPos;
	intervalPos.x = u_interval.x;
	intervalPos.y = u_interval.y;
	vec2 intervalSize;
	intervalSize.x = u_interval.z;
	intervalSize.y = u_interval.w;
		
	//UV Gradient
	vec2 uvGradient;
	uvGradient.x = intervalPos.x + (intervalSize.x * (v_color.a * u_multiplier.x + (gsColor + 1.0)));
	uvGradient.y = u_multiplier.y * uvGradient.x;
	
	//get gradient texture color
	vec4 gradientColor = texture2D(u_texture1, uvGradient);

	gl_FragColor.rgb = gradientColor.rgb * v_color.rgb * 1.0;
	gl_FragColor.a = baseColor.a * gradientColor.a;
}
