attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec4 a_normal;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
varying lowp vec4 v_color;
varying lowp vec2 v_matCapCoord;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	vec3 e = vec3(u_modelViewMatrix * a_position);
	vec3 n = vec3(u_modelViewMatrix * vec4(a_normal.xyz,0.0));
	v_color = a_color * vec4(a_color.a, a_color.a, a_color.a, 1.0);	/* Premultiply alpha */
    vec3 r = reflect( e, n );	
    float m = 2.0 * sqrt( pow( r.x, 2.0 ) + pow( r.y, 2.0 ) + pow( r.z + 1.0, 2.0 ) );	
    v_matCapCoord = r.xy / m + 0.5;

}