attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelMatrix;
uniform highp vec4 u_inverseTextureWidth;
uniform highp vec4 u_scale;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

void main() {
    gl_Position = u_modelViewProjectionMatrix * a_position;

	highp mat4 matrixScale = mat4(0);
	matrixScale[0][0] = u_scale[0];
	matrixScale[1][1] = u_scale[1];
	matrixScale[2][2] = u_scale[2];
	matrixScale[3][3] = 1.0;
	 
	highp vec4 posw = matrixScale * a_position;
	
    v_color = vec4(1.0, 1.0, 1.0, 1.0);
    v_texCoord = vec2((posw.x * u_inverseTextureWidth.x), a_texCoord.y);
}