attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelMatrix;
uniform lowp vec4 u_inverseTextureWidthAndDirection;
uniform lowp vec4 u_timeOffset;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

void main() {
	float ROUND_FACTOR_MAX = 0.992;
	float ROUND_FACTOR_MIN = 0.01;
    gl_Position = u_modelViewProjectionMatrix * a_position;
	vec4 posw = u_modelMatrix * a_position;
    v_color = vec4(1.0, 1.0, 1.0, 1.0);
    v_texCoord = vec2((posw.x * u_inverseTextureWidthAndDirection.x) + u_timeOffset.x * u_inverseTextureWidthAndDirection.y, clamp(a_texCoord.y,ROUND_FACTOR_MIN,ROUND_FACTOR_MAX));
}