uniform sampler2D u_texture;
uniform lowp vec4 u_materialDiffuse;
uniform lowp vec4 u_materialSpecular;
uniform lowp vec4 u_materialEmissive;
varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp float v_rotatedPosition;
varying lowp float v_size;

void main() {
	lowp vec4 baseColor = texture2D(u_texture, v_texCoord);
	baseColor *= baseColor.a;
	lowp float isStripe = mod(floor(v_rotatedPosition * v_size), 4.0);

	if(isStripe == 0.0 ){
		gl_FragColor.rgb = u_materialDiffuse.rgb;
	
		}
	if(isStripe == 1.0 ){
		gl_FragColor.rgb = u_materialSpecular.rgb;
		}
	if(isStripe == 2.0 ){
		gl_FragColor.rgb = u_materialEmissive.rgb;
		}
	if(isStripe == 3.0 ){
		gl_FragColor.rgb = v_color.rgb;
		}

	gl_FragColor.a = baseColor.a;

}