varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1; // normal map

void main() {

	vec3 N = normalize(texture2D( u_texture1, vec2(v_texCoord.x,-v_texCoord.y) ).rgb*2.0 - 1.0); // texture normal in tangent space. in 2D ... we can avoid TBN multiplication and lighting calculation in texture space.
	vec3 top = vec3(0.0, 0.0, 1.0);
	
	float cosTheta = clamp(dot(N, top), 0.0, 1.0);	
	vec4 textureColor = texture2D(u_texture, v_texCoord);
	gl_FragColor = vec4(textureColor.rgb * cosTheta, textureColor.a);
}