varying mediump vec2 v_texCoord;
varying highp vec4 v_clippingBoxLeftTop;
varying highp vec4 v_clippingBoxRightBottom;
varying highp vec4 v_position;

uniform sampler2D u_texture;

void main()
{
	lowp float leftCoeff = step(v_clippingBoxLeftTop.x, v_position.x);
	lowp float rightCoeff = step(v_position.x, v_clippingBoxRightBottom.x);
	lowp float topCoeff = step(v_clippingBoxLeftTop.y, v_position.y);
	lowp float bottomCoeff = step(v_position.y, v_clippingBoxRightBottom.y);
	
	lowp vec4 coeff = vec4(1.0, 1.0, 1.0, leftCoeff * rightCoeff * topCoeff * bottomCoeff);

	gl_FragColor =  coeff * texture2D(u_texture, v_texCoord);
}