attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_projectionMatrix;
uniform highp mat4 u_viewMatrix;
uniform lowp vec4 u_clippingBoxLeftTop;
uniform lowp vec4 u_clippingBoxRightBottom;

varying mediump vec2 v_texCoord;

varying highp vec4 v_clippingBoxLeftTop;
varying highp vec4 v_clippingBoxRightBottom;
varying highp vec4 v_position;

void main()
{
	v_clippingBoxLeftTop = u_viewMatrix * u_clippingBoxLeftTop;
	v_clippingBoxRightBottom = u_viewMatrix * u_clippingBoxRightBottom;

	v_position = u_modelViewMatrix * a_position;
	gl_Position = u_projectionMatrix * v_position;
	v_texCoord = a_texCoord;
}