varying lowp vec4 v_color;

uniform sampler2D u_texture;
uniform highp vec4 u_textureMappingHeightShiftAndInverseSize; // x: texturShiftY; y: inverseScreenWidth; z: inverse texture height

void main() {
	
	float texturShiftY = u_textureMappingHeightShiftAndInverseSize.x;
	float inverseScreenWidth = u_textureMappingHeightShiftAndInverseSize.y;
	float inverseTextureHeight = u_textureMappingHeightShiftAndInverseSize.z;

	vec2 uv = gl_FragCoord.xy;	
	uv.s = uv.s * inverseScreenWidth;
	uv.t = -(uv.t + texturShiftY) * inverseTextureHeight;
	
	gl_FragColor = v_color * texture2D(u_texture, uv);
}