varying highp vec2 v_texCoord;
varying highp vec2 v_texCoord2;
varying lowp vec4 v_color;

uniform highp float u_time;
uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform mediump vec4 dist_strength;

varying highp vec2 scrollUV1;
varying highp vec2 scrollUV2;

void main()
{
	mediump vec2 distortTex1 = texture2D(u_texture1, scrollUV1).rg*2.0-1.0;
	mediump vec2 distortTex2 = texture2D(u_texture1, scrollUV2).rg*2.0-1.0;
	mediump vec4 distortMask = texture2D(u_texture1, v_texCoord2);
	mediump vec2 final_uv_distortion1 = dist_strength.xy * distortTex1.rg * distortMask.a * v_color.b;
	mediump vec2 final_uv_distortion2 = dist_strength.zw * distortTex2.rg * distortMask.a * v_color.b;
	mediump vec2 final_uv_distortion1_nomask = texture2D(u_texture1, scrollUV1).rg;
	mediump vec2 final_uv_distortion2_nomask = texture2D(u_texture1, scrollUV2).rg;
	
	mediump vec4 texColor = texture2D(u_texture, v_texCoord+(final_uv_distortion1+final_uv_distortion2));
	mediump vec4 erosionTex = texture2D(u_texture1, v_texCoord+(final_uv_distortion1_nomask+final_uv_distortion2_nomask));
	
	mediump float erosion = dot(vec3(erosionTex.r,erosionTex.g,0.0), vec3(0.299, 0.587, 0.114))*4.0;
	mediump float alpha = texColor.a-smoothstep(0.8,1.0,clamp(erosion*(1.0-v_color.a),0.0,1.0));
	

	//gl_FragColor = vec4(alpha,alpha,alpha, 1.0);
	gl_FragColor = vec4(texColor.xyz ,alpha);
}
