attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp float u_time;

uniform highp vec4 uv_tiling_scroll_t0; // red channel texture: (tiling_x, tiling_y, speed_x, speed_y)
uniform highp vec4 uv_tiling_scroll_t1; // green channel texture: (tiling_x, tiling_y, speed_x, speed_y)
uniform lowp vec4 tint_t0; // tint red channel texture
uniform lowp vec4 tint_t1; // tint green channel texture

varying highp vec2 scrollUV0;
varying highp vec2 scrollUV1;
varying highp vec4 v_color;
varying highp vec2 v_texCoord;

void main()
{
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	v_texCoord = a_texCoord;
	
	scrollUV0 = (v_texCoord.xy * uv_tiling_scroll_t0.xy) + fract(u_time * uv_tiling_scroll_t0.zw);
	scrollUV1 = (v_texCoord.xy * uv_tiling_scroll_t1.xy) + fract(u_time * uv_tiling_scroll_t1.zw);
}