varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp vec4 v_styleParams;
varying lowp vec4 v_glyphParams;

uniform sampler2D u_texture;

void main() {	
    mediump float packedAlpha = texture2D(u_texture, v_texCoord).a;
    lowp float glyphEdge = v_glyphParams.x;
    lowp float fieldStep = v_glyphParams.y;
    lowp float softnessSize = v_glyphParams.z;
    lowp float outlineSize = v_styleParams.z;
    lowp float outlineSoftness = v_styleParams.w;

    float bval = step(0.5, outlineSize);
    float outlineAmount = outlineSize * fieldStep;
    float edge = glyphEdge - outlineAmount;
    float t0 = smoothstep(edge - softnessSize * fieldStep, edge + fieldStep, packedAlpha);
    float t1 = step(edge - (softnessSize * fieldStep), packedAlpha);
    float threshold = mix(t0, t1, bval);
	vec4 c = vec4(v_color.rgb, threshold * v_color.a);
    c.a = mix(c.a, smoothstep(edge - 2.0 * fieldStep, edge, packedAlpha), bval);
    gl_FragColor = c;
}