attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;

uniform lowp vec4 u_color4;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

vec4 premultiply(vec4 color) {
	return vec4(
		color.r * color.a,
		color.g * color.a,
		color.b * color.a,
		color.a);
}

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color * premultiply(u_color4);
	v_texCoord = a_texCoord;
}