local tutorialName = "dynamic_tutorial_aiming"
local linkColor = ""
local notAimingMovesCount = 0
local itemTags = {"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40"}
local taggedItemsLive = {}
local tutorialHasBeenShown = false

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	if not tutorialHasBeenShown then
		linkColor = color

		local list = ParseList(typesList)
		for i=1,#list do
			local checkedType = list[i]
			if checkedType == "powerup_bomb" or checkedType == "powerup_chaos_ray" or checkedType == "powerup_cross" or checkedType == "powerup_line_blast_horizontal" or checkedType == "powerup_line_blast_vertical" then
				API_Log("DYNAMIC TUTOR: Link contains PU")
				API_EnableCheckBoardStable("true")
				API_SetAllowedLinking("false")
			end
		end
	end
end

local function InternalOnBoardStable()
	if not tutorialHasBeenShown then
		local hasAimed = false
		for i=1,#itemTags do
			local health = API_GetItemHealth(itemTags[i])
			if taggedItemsLive[i] ~= health then
				hasAimed = true
				taggedItemsLive[i] = health
			end
		end

		if not hasAimed then
			notAimingMovesCount = notAimingMovesCount + 1
			API_Log("DYNAMIC TUTOR: Links without aiming: "..notAimingMovesCount)
			if notAimingMovesCount >= 2 then
				local result = API_PlayDynamicTutorial("aiming", linkColor, "", "")
				tutorialHasBeenShown = API_StringToBool(result)
				
				if tutorialHasBeenShown then
					API_IncrementTutorialShownCount(tutorialName)
				end
			end
		else
			notAimingMovesCount = 0
		end
	end
	
	API_SetAllowedLinking("true")
	API_EnableCheckBoardStable("false")
	
	API_Log("DYNAMIC TUTOR: Board stabilised")
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnBoardStableCallback(InternalOnBoardStable)

		for i=1,#itemTags do
			local health = API_GetItemHealth(itemTags[i])
			table.insert(taggedItemsLive, health)
		end
		
		API_Log("DYNAMIC TUTOR: Dynamic tutorial for aiming started")
	end
end

RegisterOnStartCallback(InternalOnStart)
