require "string"

function ParseList(unparsedList)
	local list = {}
	for element in string.gmatch(unparsedList, "[^,]+") do table.insert(list, element) end
	return list
end

local onDiamondNotMovedCallbacks = {}

function RegisterOnDiamondNotMovedCallback(callback)
	table.insert(onDiamondNotMovedCallbacks, callback)
end

function OnDiamondNotMoved(typeName, colorName)
	for i=1,#onDiamondNotMovedCallbacks do
		onDiamondNotMovedCallbacks[i](typeName, colorName)
	end
end

local onItemCreatedCallbacks = {}

function RegisterOnItemCreatedCallback(callback)
	table.insert(onItemCreatedCallbacks, callback)
end

function OnItemCreated(typeName, colorName)
	for i=1,#onItemCreatedCallbacks do
		onItemCreatedCallbacks[i](typeName, colorName)
	end
end

local onLinkFailedCallbacks = {}

function RegisterOnLinkFailedCallback(callback)
	table.insert(onLinkFailedCallbacks, callback)
end

function OnLinkFailed()
	for i=1,#onLinkFailedCallbacks do
		onLinkFailedCallbacks[i]()
	end
end

local onLinkCompletedCallbacks = {}

function RegisterOnLinkCompletedCallback(callback)
	table.insert(onLinkCompletedCallbacks, callback)
end

function OnLinkCompleted(color, typesList, length, groupLength)
	for i=1,#onLinkCompletedCallbacks do
		onLinkCompletedCallbacks[i](color, typesList, length, groupLength)
	end
end

local onLinkCancelledCallbacks = {}

function RegisterOnLinkCancelledCallback(callback)
	table.insert(onLinkCancelledCallbacks, callback)
end

function OnLinkCancelled()
	for i=1,#onLinkCancelledCallbacks do
		onLinkCancelledCallbacks[i]()
	end
end

local onBoardStableCallbacks = {}

function RegisterOnBoardStableCallback(callback)
	table.insert(onBoardStableCallbacks, callback)
end

function OnBoardStable()
	for i=1,#onBoardStableCallbacks do
		onBoardStableCallbacks[i]()
	end
end

local onStartCallbacks = {}

function RegisterOnStartCallback(callback)
	table.insert(onStartCallbacks, callback)
end

function OnStart()
	for i=1,#onStartCallbacks do
		onStartCallbacks[i]()
	end
end
