local tutorialName = "bird_triggered"
local tutorialHasBeenShown = false

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	if not tutorialHasBeenShown then
		local types = ParseList(typesList)
		for i=1,#types do
			if types[i] == "powerup_fish" then
				local result = API_PlayDynamicTutorial("bird", color, "", "")
				tutorialHasBeenShown = API_StringToBool(result)
				
				if tutorialHasBeenShown then
					API_IncrementTutorialShownCount(tutorialName)
				end
				break
			end
		end
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Birds tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
	end
end

RegisterOnStartCallback(InternalOnStart)
