local linkColor = ""
local tutorialName = "bomb_created"
local tutorialHasBeenShown = false

local function InternalOnItemCreated(typeName, colorName)
	if typeName == "powerup_bomb" and not tutorialHasBeenShown then
		API_Log("DYNAMIC TUTOR: Player created bomb")
		API_CallFunctionAfterDelay("TriggerBombTooltip", colorName, "1")
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	linkColor = color
end

function TriggerBombTooltip(colorName)
	local result = API_PlayDynamicTutorial("bomb", linkColor, "bomb", colorName)
	tutorialHasBeenShown = API_StringToBool(result)

	if tutorialHasBeenShown then
		API_IncrementTutorialShownCount(tutorialName)
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Bomb creation tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnItemCreatedCallback(InternalOnItemCreated)
	end
end

RegisterOnStartCallback(InternalOnStart)
