local tutorialName = "bottles"
local tutorialHasBeenShown = false
local linkCount = 0
local tutorialItemType = "fluid_bottle"
local maxFailedLinks = 2

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	if not tutorialHasBeenShown then
		local isTypeInLink = false
		local isPowerUpCreated = false
		local isPowerUpLinked = false
		
		local list = ParseList(typesList)
		for i=1,#list do
			if list[i] == tutorialItemType then
				isTypeInLink = true
				API_Log("DYNAMIC TUTOR: Bottle linked")
			elseif list[i] == "powerup_bomb" or list[i] == "powerup_chaos_ray" or list[i] == "powerup_cross" or list[i] == "powerup_line_blast_horizontal" or list[i] == "powerup_line_blast_vertical" then
				isPowerUpLinked = true
				API_Log("DYNAMIC TUTOR: Powerup linked")
			end
		end
		
		if length >= "6" then
			isPowerUpCreated = true
			API_Log("DYNAMIC TUTOR: Powerup created")
		end

		if not isTypeInLink and not isPowerUpCreated and not isPowerUpLinked then
			if API_ExistsLink("with_bottle") == "true" then
				linkCount = linkCount + 1
				API_Log("DYNAMIC TUTOR: Player didn't link bottle "..linkCount.." times")
				if linkCount >= maxFailedLinks then
					API_Log("DYNAMIC TUTOR: Bottles hint shown")
					
					local result = API_PlayDynamicTutorialHint("bottles", "false")
					tutorialHasBeenShown = API_StringToBool(result)
				
					if tutorialHasBeenShown then
						API_IncrementTutorialShownCount(tutorialName)
					end
				end
			end
		else
			linkCount = 0
		end
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "5" then
		API_Log("DYNAMIC TUTOR: Bottle tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
	end
end

RegisterOnStartCallback(InternalOnStart)
