local linkColor = ""
local tutorialName = "chaos_ray_created"
local tutorialHasBeenShown = false

local function InternalOnItemCreated(typeName, colorName)
	if typeName == "powerup_chaos_ray" and not tutorialHasBeenShown then
		API_Log("DYNAMIC TUTOR: Player created chaos ray")
		API_CallFunctionAfterDelay("TriggerChaosRayTooltip", colorName, "1")
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	linkColor = color
end

function TriggerChaosRayTooltip(colorName)
	local result = API_PlayDynamicTutorial("star", linkColor, "star", colorName)
	tutorialHasBeenShown = API_StringToBool(result)
	
	if tutorialHasBeenShown then
		API_IncrementTutorialShownCount(tutorialName)
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Chaos ray tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnItemCreatedCallback(InternalOnItemCreated)
	end
end

RegisterOnStartCallback(InternalOnStart)
