local linkColor = ""
local tutorialName = "color_bomb_created"
local tutorialHasBeenShown = false

local function InternalOnItemCreated(typeName, colorName)
	if typeName == "powerup_color_bomb" and not tutorialHasBeenShown then
		API_Log("DYNAMIC TUTOR: Player created color bomb")
		API_CallFunctionAfterDelay("TriggerColorBombTooltip", colorName, "1")
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	linkColor = color
end

function TriggerColorBombTooltip(colorName)
	local result = API_PlayDynamicTutorial("color_bomb", linkColor, "color_bomb", colorName)
	tutorialHasBeenShown = API_StringToBool(result)
	
	if tutorialHasBeenShown then
		API_IncrementTutorialShownCount(tutorialName)
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Color bomb tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnItemCreatedCallback(InternalOnItemCreated)
	end
end

RegisterOnStartCallback(InternalOnStart)
