local linkColor = ""
local tutorialName = "cross_created"
local tutorialHasBeenShown = false


local function InternalOnItemCreated(typeName, colorName)
	if typeName == "powerup_cross" and not tutorialHasBeenShown then
		API_Log("DYNAMIC TUTOR: Player created cross")
		API_CallFunctionAfterDelay("TriggerCrossTooltip", colorName, "1")
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	linkColor = color
end

function TriggerCrossTooltip(colorName)
	local result = API_PlayDynamicTutorial("cross", linkColor, "cross", colorName)
	tutorialHasBeenShown = API_StringToBool(result)

	if tutorialHasBeenShown then
		API_IncrementTutorialShownCount(tutorialName)
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Cross creation tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnItemCreatedCallback(InternalOnItemCreated)
	end
end

RegisterOnStartCallback(InternalOnStart)
