local tutorialName = "cross_the_line"
local tutorialHasBeenShown = false
local linkCount = 0
local maxFailedLinks = 2
local diamondNotMoved = false

local function InternalDiamondNotMoved()
	API_Log("DYNAMIC TUTOR: Diamond not moved")
	diamondNotMoved = true
end

local function InternalOnBoardStable()
	API_Log("DYNAMIC TUTOR: Board stabilised")
	if not tutorialHasBeenShown then
		if diamondNotMoved then
			IncrementLinkCounter()
		else
			linkCount = 0
		end
	end
	
	API_EnableCheckBoardStable("false")
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	diamondNotMoved = false
	if not tutorialHasBeenShown then
		API_EnableCheckBoardStable("true")
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "5" then
		API_Log("DYNAMIC TUTOR: Cross the line tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnBoardStableCallback(InternalOnBoardStable)
		RegisterOnDiamondNotMovedCallback(InternalDiamondNotMoved)
		API_EnableCheckDiamondMovement("true")
	end
end

function IncrementLinkCounter()
	linkCount = linkCount + 1
	API_Log("DYNAMIC TUTOR: Current tutorial link count = "..linkCount)
	if linkCount >= maxFailedLinks then
		API_Log("DYNAMIC TUTOR: Cross the line hint shown")
		local result = API_PlayDynamicTutorialHint("cross_the_line", "false")

		tutorialHasBeenShown = API_StringToBool(result)
				
		if tutorialHasBeenShown then
			API_IncrementTutorialShownCount(tutorialName)
			API_EnableCheckDiamondMovement("true")
		end
	end
end

RegisterOnStartCallback(InternalOnStart)
