local linkColor = ""
local lineType = ""
local tutorialName = "line_created"
local tutorialHasBeenShown = false

local function InternalOnItemCreated(typeName, colorName)
	if not tutorialHasBeenShown then
		if typeName == "powerup_line_blast_horizontal" then
			API_Log("DYNAMIC TUTOR: Player created horizontal line blast")
			lineType = "line_hori"
			API_CallFunctionAfterDelay("TriggerLineTooltip", colorName, "1")
		end
		if typeName == "powerup_line_blast_vertical" then
			API_Log("DYNAMIC TUTOR: Player created vertical line blast")
			lineType = "line_vert"
			API_CallFunctionAfterDelay("TriggerLineTooltip", colorName, "1")
		end
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	linkColor = color
end

function TriggerLineTooltip(color)
	local result = API_PlayDynamicTutorial("line", linkColor, lineType, color)
	tutorialHasBeenShown = API_StringToBool(result)
	
	if tutorialHasBeenShown then
		API_IncrementTutorialShownCount(tutorialName)
	end
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "3" then
		API_Log("DYNAMIC TUTOR: Line blast tutorial started")
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
		RegisterOnItemCreatedCallback(InternalOnItemCreated)
	end
end

RegisterOnStartCallback(InternalOnStart)
