local tutorialName = "linking"
local tutorialHasBeenShown = false
local failedLinkCount = 0
local maxFailedLinks = 3

local function InternalOnLinkFailed()
	API_Log("DYNAMIC TUTOR: Player failed to link")
	failedLinkCount = failedLinkCount + 1
	if failedLinkCount >= maxFailedLinks and not tutorialHasBeenShown then
		API_Log("DYNAMIC TUTOR: Linking hint shown")
		
		local result = API_PlayDynamicTutorialHint("linking", "false")
		tutorialHasBeenShown = API_StringToBool(result)
		
		if tutorialHasBeenShown then
			API_IncrementTutorialShownCount(tutorialName)
		end
	end
end

local function InternalOnLinkCompleted(color, typesList, length, groupLength)
	failedLinkCount = 0
end

local function InternalOnStart()
	if API_GetTutorialShownCount(tutorialName) < "5" then
		API_Log("DYNAMIC TUTOR: Linking tutorial started")
		RegisterOnLinkFailedCallback(InternalOnLinkFailed)
		RegisterOnLinkCompletedCallback(InternalOnLinkCompleted)
	end
end

RegisterOnStartCallback(InternalOnStart)
