function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
	
	gates1opened = false
	gates2opened = false
end



function onTutorialInitialized()
	if tutorialStep == 0 then
		LinkBomb()
	elseif tutorialStep == 2 then
		CreateBomb()
	end
end



function LinkBomb()
	API_Log("*** Link bomb")
	API_SetTutorialTextBody("tutorial_bomb_trigger")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("0,1,2", "any_order", "0.3")
	API_ShowFingerAnimation("0,1,2", 1);
end



function CreateBomb()
	API_Log("*** Create bomb")
	API_SetTutorialTextBody("tutorial_bomb_create")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("6,7,8,9,10", "any_order", "0.3")
	API_ShowFingerAnimation("6,7,8,9,10", 1);
end



function onBoardChanged()
	API_Log("**************onBoardChanged")
	tutorialStep = 2
	API_StartTutorial("interactive")
end



function OpenGates1()
	API_Translate(3, -125, 0, 0.5)
	API_Translate(4, -75, 0, 0.5)
end



function OpenGates2()
	API_Translate(11, 125, 0, 0.5)
	API_Translate(12, 75, 0, 0.5)
end



function CloseGates1()
	API_Translate(4, 75, 0, 0.5)
	API_Translate(5, 230, 0, 0.5)
end



function CloseGates2()
	API_Translate(12, -75, 0, 0.5)
	API_Translate(13, -230, 0, 0.5)
end



function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	
	if gates1opened == true then
		CloseGates1 ()
		gates1opened = false
	end
	
	if gates2opened == true then
		CloseGates2 ()
		gates2opened = false
	end
	
	if tutorialStep == 0 then
		tutorialStep = 1
		OpenGates1()
		gates1opened = true
		API_EndTutorial()
	elseif tutorialStep == 2 then
		tutorialStep = 3
		OpenGates2()
		gates2opened = true
		API_EndTutorial()
	end
end
