function onTutorialInitialized()
	API_SetTutorialImage("art/scenes/world/common/sagamap_avatar_player.xml")
	LinkRedInAnyOrder()
end

function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
end

function LinkRedInAnyOrder()
	API_Log("*** Link red in any order")
	API_SetTutorialTextBody("local_keys.tutorial_link_red_in_any_order")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("1,2,3", "any_order", "0.3")
	API_ShowFingerAnimation("1,2,3", 1);
	API_EnableTaggedItems("10");
	API_EnableTaggedItems("7");
	API_DisableTaggedItems("7", "0.6");
end

function LinkGreenLeftToRightAndMiddle()
	API_Log("*** Link green in any order, finish in the middle piece")
	API_SetTutorialTextBody("local_keys.tutorial_link_green_and_finish_link_in_the_middle_piece")
	API_SetAllowedLinking("true")
	API_EnableAllItems()
	API_WaitForTutorialLink("4,6,5", "any_order_match_last", "0.3")
	API_ShowFingerAnimation("4,6,5", 1);
end

function LinkBlueRightToLeft()
	API_Log("*** Link blue right to left, start top right")
	API_SetTutorialTextBody("local_keys.tutorial_link_four_blue_starting_on_the_right")
	API_SetAllowedLinking("true")
	API_EnableAllItems()
	API_WaitForTutorialLink("10,9,8,7", "ordered", "0.3")
	API_ShowFingerAnimation("10,9,8,7", 1);
end

function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_CallFunctionAfterDelay("LinkGreenLeftToRightAndMiddle", 0, 2)
		API_SetAllowedLinking("false")
	elseif tutorialStep == 1 then
		tutorialStep = 2
		API_CallFunctionAfterDelay("LinkBlueRightToLeft", 0, 2)
		API_SetAllowedLinking("false")
	elseif tutorialStep == 2 then
		API_EndTutorial()
	end
end
